(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: htmlReportUtils.ml                                            *)
(* authors: Adrien Jonquet, Philippe Wang, Alexis Darrasse             *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)

let color_expression co i statements =
  let rec aux = function 
      [] -> ()
    | cover_expr :: l ->
	begin
	  if i = cover_expr.Coverage.cnum_start then
	    begin
	      match cover_expr.Coverage.status with
		  Coverage.Covered ->
		    begin
		      match cover_expr.Coverage.event.Covevent.covev_status with
			  Covevent.Coverage_event_statement -> 
			    output_string co "<SPAN CLASS=covered>" 
			| Covevent.Coverage_event_condition _ ->  
			    output_string co "<SPAN CLASS=covered_condition>"
			| Covevent.Coverage_event_decision -> 
			    output_string co "<SPAN CLASS=covered_decision>" 
		    end
		| Coverage.Uncovered ->
		    begin
		      match cover_expr.Coverage.event.Covevent.covev_status with
			  Covevent.Coverage_event_statement -> 
			    output_string co "<SPAN CLASS=uncovered>" 
			| Covevent.Coverage_event_condition _ ->  
			    output_string co "<SPAN CLASS=uncovered_condition>"

			| Covevent.Coverage_event_decision -> 
			    output_string co "<SPAN CLASS=uncovered_decision>" 
		    end
	    end
	  else
	    if i = cover_expr.Coverage.cnum_end then
	      output_string co "</SPAN>"
	end;
	aux l
  in
    aux statements
