(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: main.ml                                                       *)
(* authors: Adrien Jonquet, Philippe Wang, Alexis Darrasse             *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)

(* cmd args *)
let nb_instr = ref 0
  
let _ = 
  let exec_trace_file_names = ref [] in
  let mcdc_trace_file_names = ref [] in
    Arg.parse 
      [("-mcdc", Arg.String (fun s -> mcdc_trace_file_names := 
			       s :: !mcdc_trace_file_names), 
	"mcdc trace files ");
       ("-trace", Arg.String (fun s -> exec_trace_file_names := 
				s :: !exec_trace_file_names), 
	"exec trace files"); 
       ("-exec", Arg.String (fun s -> Cover.exec := s ), 
	"executable")]
      (fun _ -> ())
      (Sys.argv.(0)^" [options] executable");
    if not (Sys.file_exists !Cover.exec) then
      failwith "executable file does not exist";
    (* load the OCaml bytecode exe *)
    let data = Bytecode_loader.load_file !Cover.exec in
      (* the size in byte of the bytecode *)
      Cover.init_cover !Cover.exec data !exec_trace_file_names !mcdc_trace_file_names;
      Cover.cover_object data;
      Cover.cover_source !exec_trace_file_names !mcdc_trace_file_names
;;
