(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: trace.ml                                                      *)
(* authors: Adrien Jonquet, Philippe Wang, Alexis Darrasse             *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)

open EventType

type trace_hist = { 
  pos : int;
  instr : Instructions.instruction;
}

type statement_trace = No_instr | Trace_hist of trace_hist

let record_instruction pc exec_trace instr =
  let hist = { 
    pos = pc * 4;
    instr = instr;
  }
  in
    (* record the instr in the trace *)
    begin
      match exec_trace.(pc) with
	  No_instr -> exec_trace.(pc) <- Trace_hist hist
	| Trace_hist t -> () (* this means that we already have recorded the instruct *)
    end
