(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: covevent.ml                                                   *)
(* authors: Adrien Jonquet, Mathias Bourgoin                           *)
(* licence: CeCILL-B                                                   *)
(***********************************************************************)

type coverage_event =
    { mutable covev_pos: int;
      covev_module: string;
      covev_loc: Location.t;
      covev_kind: coverage_event_kind;
      covev_status: coverage_event_status }

and coverage_event_kind =
    Coverage_event_before
  | Coverage_event_after of Types.type_expr
  | Coverage_event_function

and coverage_event_status = 
    Coverage_event_statement
  | Coverage_event_decision
  | Coverage_event_condition of coverage_event list
  