(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: covutils.mli                                                  *)
(* authors: Adrien Jonquet, Mathias Bourgoin                           *)
(* licence: CeCILL-B                                                   *)
(***********************************************************************)

open Misc
open Asttypes
open Primitive
open Path
open Types
open Typedtree
open Typeopt
open Lambda

type from_dec = 
   False 
 | True of lambda_covevent list

val string_of_expression_desc : (Typedtree.expression_desc -> string)      

val print : (string -> unit)

val put_before : (Typedtree.expression -> Lambda.lambda -> Lambda.lambda_covevent_status -> Lambda.lambda)

val put_after : (Typedtree.expression -> Lambda.lambda -> Lambda.lambda_covevent_status -> Lambda.lambda)

val put_covev : (Typedtree.expression -> Lambda.lambda -> Lambda.lambda_covevent_status -> Lambda.lambda)

val is_bool : (Types.type_desc -> bool)

val build_lambda_covev : Typedtree.expression -> string -> Lambda.lambda_covevent_status ->  Lambda.lambda_covevent
